Ripper fails to tokenize `def f; (x)::A =`

07/24/2024 07:06 AM - tompng (tomoya ishida)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.4.0dev (2024-07-24T05:44:32Z

master e642ddf7ae) [x86_64-linux]

Backport: 3.1: REQUIRED, 3.2: DONE, 3.3: DONE

Description

Ripper fails to tokenize some dynamic constant assignment syntax error code.

''::A= (x)::A= (x).y::Z= []::A= {}::A=  ``::A= //::A= %()::A= in method body seems to fail.

Same for for ''::A in and rescue => ''::A; in method body.

Ripper.tokenize 'def f; (x)::A ='

#=>

/opt/ruby/lib/ruby/3.4.0+0/ripper/lexer.rb:245:in 'Ripper::Lexer#on_error2': undefined method 

'pos' for nil (NoMethodError)

      @errors.push Elem.new(elem.pos, __callee__, elem.tok, elem.state, mesg)

                                ^^^^

 from /opt/ruby/lib/ruby/3.4.0+0/ripper/lexer.rb:176:in 'Ripper#parse'

 from /opt/ruby/lib/ruby/3.4.0+0/ripper/lexer.rb:176:in 'Ripper::Lexer#parse'

 from /opt/ruby/lib/ruby/3.4.0+0/ripper/lexer.rb:150:in 'Ripper::Lexer#tokenize'

 from /opt/ruby/lib/ruby/3.4.0+0/ripper/lexer.rb:26:in 'Ripper.tokenize'

 from -e:1:in '<main>'

Related issues:

Related to Ruby - Bug #17345: ripper: nothing raised when assigning to keywor... Closed

Associated revisions

Revision 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6 - 07/24/2024 01:18 PM - nobu (Nobuyoshi Nakada)

[Bug #20649] Allow nil as 2nd argument of assign_error

Fallback to the last token element in that case, for the backward

compatibilities.

Revision 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6 - 07/24/2024 01:18 PM - nobu (Nobuyoshi Nakada)

[Bug #20649] Allow nil as 2nd argument of assign_error

Fallback to the last token element in that case, for the backward

compatibilities.

Revision 97449338 - 07/24/2024 01:18 PM - nobu (Nobuyoshi Nakada)

[Bug #20649] Allow nil as 2nd argument of assign_error

Fallback to the last token element in that case, for the backward

compatibilities.

Revision a8a25291447e3630d455e82851ca58fc8ac372ec - 08/18/2024 01:52 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6: [Backport #20649]

    [Bug #20649] Allow `nil` as 2nd argument of `assign_error`

    Fallback to the last token element in that case, for the backward

    compatibilities.

Revision a8a25291447e3630d455e82851ca58fc8ac372ec - 08/18/2024 01:52 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6: [Backport #20649]
    [Bug #20649] Allow `nil` as 2nd argument of `assign_error`

    Fallback to the last token element in that case, for the backward

    compatibilities.

Revision a8a25291 - 08/18/2024 01:52 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6: [Backport #20649]

    [Bug #20649] Allow `nil` as 2nd argument of `assign_error`

    Fallback to the last token element in that case, for the backward

    compatibilities.

Revision b210c86a0201f6a97c4da8266908260746f53ae0 - 09/02/2024 10:07 AM - k0kubun (Takashi Kokubun)

merge revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6: [Backport #20649]

    [Bug #20649] Allow `nil` as 2nd argument of `assign_error`

    Fallback to the last token element in that case, for the backward

    compatibilities.

Revision b210c86a0201f6a97c4da8266908260746f53ae0 - 09/02/2024 10:07 AM - k0kubun (Takashi Kokubun)

merge revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6: [Backport #20649]

    [Bug #20649] Allow `nil` as 2nd argument of `assign_error`

    Fallback to the last token element in that case, for the backward

    compatibilities.

Revision b210c86a - 09/02/2024 10:07 AM - k0kubun (Takashi Kokubun)

merge revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6: [Backport #20649]

    [Bug #20649] Allow `nil` as 2nd argument of `assign_error`

    Fallback to the last token element in that case, for the backward

    compatibilities.

History

#1 - 07/24/2024 09:54 AM - nobu (Nobuyoshi Nakada)

- Related to Bug #17345: ripper: nothing raised when assigning to keyword variables added

#2 - 07/24/2024 09:54 AM - nobu (Nobuyoshi Nakada)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN to 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED

#3 - 07/24/2024 12:32 PM - nobu (Nobuyoshi Nakada)

https://github.com/ruby/ruby/pull/11235

#4 - 07/24/2024 01:45 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|97449338d6cb42d9dd7c9ca61550616e7e6b6ef6.

[Bug #20649] Allow nil as 2nd argument of assign_error

Fallback to the last token element in that case, for the backward

compatibilities.

#5 - 08/18/2024 02:20 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED to 3.1: REQUIRED, 3.2: DONE, 3.3: REQUIRED

ruby_3_2 a8a25291447e3630d455e82851ca58fc8ac372ec merged revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6.

#6 - 09/02/2024 10:07 AM - k0kubun (Takashi Kokubun)
https://github.com/ruby/ruby/pull/11235
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/97449338d6cb42d9dd7c9ca61550616e7e6b6ef6
https://redmine.ruby-lang.org/issues/20649
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/a8a25291447e3630d455e82851ca58fc8ac372ec
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/97449338d6cb42d9dd7c9ca61550616e7e6b6ef6


- Backport changed from 3.1: REQUIRED, 3.2: DONE, 3.3: REQUIRED to 3.1: REQUIRED, 3.2: DONE, 3.3: DONE

ruby_3_3 b210c86a0201f6a97c4da8266908260746f53ae0 merged revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6.
